<?php
namespace Paybylink\Payments\Controller\Checkout;

use Magento\Framework\App\ResponseInterface;
use Magento\Framework\App\Action\Action;
use Magento\Framework\App\Action\Context;
use Magento\Framework\App\CsrfAwareActionInterface;
use Magento\Framework\App\RequestInterface;
use Magento\Framework\App\Request\InvalidRequestException;
use \Paybylink\Payments\Helper\Notify as NotifyHelper;

class Notify extends Action implements CsrfAwareActionInterface
{
    private $requestParams;
    protected $_notifyHelper;

    public function __construct(Context $context, NotifyHelper $notifyHelper)
    {
        parent::__construct($context);
        $this->_notifyHelper = $notifyHelper;
        $this->requestParams = $this->getRequest()->getContent();
    }
    
    public function execute()
    {
        ob_clean();
        $this->_notifyHelper->process($this->requestParams);
        exit();
    }

    public function createCsrfValidationException(RequestInterface $request): ? InvalidRequestException
    {
        return null;
    }
        
    public function validateForCsrf(RequestInterface $request): ?bool
    {
        return true;
    }
    
}
//X-Requested-With", "XMLHttpRequest