<?php

    $shopId             = intval(123);
    $description        = strval('Opłata za parking samochodowy');
    $control            = strval('Parking-123');
    $email              = strval('test@test.pl'); // usunąć jeśli mail nie jest dołączany
    $price              = floatval(11.22);
    $notifyURL          = strval('');
    $returnUrlSuccess   = strval('');
    $hash               = 'HASH_SHA256';

    $data   = $hash . "|" . $shopId . "|" . sprintf("%.2f", $price);

    if ($control != null && $control != "") {
        $data .= "|" . $control;
    }

    if ($description != null && $description != "") {
        $data .= "|" . $description;
    }
    
    // // usunąć jeśli mail nie jest dołączany
    if ($email != null && $email != "") {
        $data .= "|" . $email;
    }

    if ($notifyURL != null && $notifyURL != "") {
        $data .= "|" . $notifyURL;
    }

    if ($returnUrlSuccess != null && $returnUrlSuccess != "") {
        $data .= "|" . $returnUrlSuccess;
    }

    $signature = hash('sha256', $data);

    $paybylinkData  = [
        'shopId'            => $shopId,
        'price'             => $price,
        'control'           => $control,
        'description'       => $description,
        'email'             => $email, // usunąć jeśli mail nie jest dołączany
        'notifyURL'         => $notifyURL,
        'returnUrlSuccess'  => $returnUrlSuccess,
        'signature'         => $signature
    ];

    $data_string = json_encode($paybylinkData);                                                                                  

    $ch = curl_init('https://secure.pbl.pl/api/v1/transfer/generate');                                                                      
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");                                                                    
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);                                                                  
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);                                                                      
    curl_setopt($ch, CURLOPT_HTTPHEADER, array(                                                                          
        'Content-Type: application/json',                                                                                
        'Content-Length: ' . strlen($data_string))                                                                      
    );    

    $result = curl_exec($ch);
    $result = json_decode($result);

    if(isset($result->transactionId) AND !empty($result->transactionId)) {
        $payURL = ('https://secure.pbl.pl/transfer/' . $result->transactionId);
    } else {
        echo 'Wystąpił błąd.';
    }

?>