<?php
class TransferGenerateRequest{
    public $shopId;//that is set in sendTransferGenerateRequest
    public $price;
    public $control;
    public $description;
    public $email;
    public $notifyURL;
    public $returnUrlSuccess;
    public $returnUrlSuccessTidPass;
    public $hideReceiver;
    public $signature;
    public $test;

    public function __construct($price) {
        $this -> price = $price;
    }

    public function setControl($control) {
        $this -> control = $control;
    }

    public function setReturnUrlSuccess($url) {
        $this -> returnUrlSuccess = $url;
    }

    public function setEmail($email) {
        $this -> email = $email;
    }

    public function setNotifyUrl($url) {
        $this -> notifyURL = $url;
    }

    public function validateFields() {
        $this -> control = $this -> control . "";
        if ($this -> price == null || !is_numeric($this -> price)) {
            return false;
        }

        $this -> price = floatval($this -> price);
        return true;
    }

    public function calculateSignature($key, $algo) {
        $priceFormatted = number_format($this -> price, 2);
        $data = $key . "|" . $this -> shopId . "|" . $priceFormatted;
        if ($this -> control != null && $this -> control != "") {
            $data .= "|" . $this -> control;
        }
        if ($this -> description != null && $this -> description != "") {
            $data .= "|" . $this -> description;
        }
        if ($this -> email != null && $this -> email != "") {
            $data .= "|" . $this -> email;
        }
        if ($this -> notifyURL != null && $this -> notifyURL != "") {
            $data .= "|" . $this -> notifyURL;
        }
        if ($this -> returnUrlSuccess != null && $this -> returnUrlSuccess != "") {
            $data .= "|" . $this -> returnUrlSuccess;
        }
        if ($this -> returnUrlSuccessTidPass != null && $this -> returnUrlSuccessTidPass != "") {
            $data .= "|" . $this -> returnUrlSuccessTidPass;
        }
        if ($this -> hideReceiver != null && $this -> hideReceiver != "") {
            $data .= "|" . $this -> hideReceiver;
        }
        $data = hash($algo, $data);
        $this -> signature = $data;
        return $data;
    }

    public function setShopId($shopId) {
        $this -> shopId = $shopId;
    }
    
}